#ifndef CL_BASESTACK_H_INCLUDED
#define CL_BASESTACK_H_INCLUDED 1

#include <e32base.h>
#include <app_context.h>

class CBaseStack : public CBase {
public:
	struct TBaseItem {
		TInt		iBaseId;
		TBuf<50>	iBaseName;
		TTime		iEntered;
		TTime		iLeft;

		TBaseItem();
		TBaseItem(const TBaseItem& anItem);
		TBaseItem(TInt aBaseId, const TDesC& aBaseName, const TTime& anEntered);
		TBaseItem& operator=(const TBaseItem& aItem);
		void Reset();
	};
	static CBaseStack* NewL(MApp_context& Context);
	~CBaseStack();

	virtual void DeleteLastL() = 0;
	virtual void DeleteFirstL() = 0;
	virtual TBool LastL(TBaseItem& anItem) = 0;
	virtual TBool PrevL(TBaseItem& anItem) = 0;
	virtual TBool FirstL(TBaseItem& anItem) = 0;
	virtual TBool NextL(TBaseItem& anItem) = 0;
	virtual void PushBackL(const TBaseItem& anItem) = 0;
	virtual TInt CountL() = 0;
	virtual void SetLastLeft(const TTime& aLeft) = 0;
	virtual void SetLastName(const TDesC& aName) = 0;
};
	
#endif
